/***************************************************************************
 * This file is part of the BF527 doorbell application.                    *
 * Doorbell is a VOIP-based outdoor doorbell that can be run on SIP-based  *
 * telephone systems (PBX).                                                *
 *                                                                         *
 * Copyright (C) 2009,2010 by BerLinux Solutions GmbH                      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

#ifndef DIALOG_H_
#define DIALOG_H_
#include <disko.h>

class Dialog {

	protected:
		bool              hasCancelBtn;
		int               exitCode;
		MMSWindow        *win;
		MMSDialogManager  dm;
		MMSConfigData     config;

		void loadDialog(const char *name);
		void onReturn(MMSWidget *wid);

	public:
		MMSWidget                    *cancelBtn;
		sigc::signal<void, Dialog *, bool>  onExit;

		Dialog(bool hasCancelBtn = true);
		virtual ~Dialog();
		virtual void show();
		virtual void hide();

		int getExitCode();
};

#endif /* DIALOG_H_ */
