/***************************************************************************
 * This file is part of the BF527 doorbell application.                    *
 * Doorbell is a VOIP-based outdoor doorbell that can be run on SIP-based  *
 * telephone systems (PBX).                                                *
 *                                                                         *
 * Copyright (C) 2009,2010 by BerLinux Solutions GmbH                      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

#ifdef __EPCBF527__

#ifndef GPIOTHREAD_H_
#define GPIOTHREAD_H_

#include <mmstools/mmsthread.h>
#include <mmstools/tools.h>
#include "sipbackend.h"

class GPIOThread: public MMSThread {
	public:
		GPIOThread(Sipbackend*);
		~GPIOThread();

		void threadMain();
		
	private:
		Sipbackend	*sip;
	
		FILE* initializeButton(unsigned char);
};

MMS_CREATEERROR(GPIOError);

#endif /* GPIOTHREAD_H_ */

#endif /* __EPCBF527__ */
