/***************************************************************************
 * This file is part of the BF527 doorbell application.                    *
 * Doorbell is a VOIP-based outdoor doorbell that can be run on SIP-based  *
 * telephone systems (PBX).                                                *
 *                                                                         *
 * Copyright (C) 2009,2010 by BerLinux Solutions GmbH                      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

#ifndef MAINMENU_H_
#define MAINMENU_H_

#include <disko.h>
#include "dialog.h"
#include "userfilereader.h"
#include <map>

#define ACT_UKN  0
#define ACT_UP   1
#define ACT_DOWN 2

class MainMenu : public Dialog {
	public:
		MainMenu(USER_MAP *users);
		~MainMenu();
		void              rewind();
		MMSMenuWidget    *lodgerMenu;
		MMSWidget        *pinButton;
		MMSLabelWidget   *uplabel;
		MMSLabelWidget   *downlabel;

	private:
		USER_MAP         *users;
		MMSWidget        *up;
		MMSWidget        *down;
		size_t            lastSel;
		int               lastAct;

		//! animation thread object for the animated theme switch
    		MMSPulser	animThread;

    	//! temporary window for animated theme switch
    	MMSFBWindow 		*anim_saved_screen;

    	//! temporary opacity of anim_saved_screen window for animated theme switch
    	int					anim_opacity;

        //! Internal method: Before Animation callback from MMSAnimationThread used in onThemeChanged() callback.
        bool onBeforeAnimation(MMSPulser *animThread);

        //! Internal method: Animation callback from MMSAnimationThread used in onThemeChanged() callback.
        bool onAnimation(MMSPulser *animThread);

        //! connection object for MMSAnimationThread::onBeforeAnimation callback
        sigc::connection 	onBeforeAnimation_connection;
        //! connection object for MMSAnimationThread::onAnimation callback
        sigc::connection 	onAnimation_connection;

		void onUp(MMSWidget *widget);
		void onDown(MMSWidget *widget);
};

#endif /* MAINMENU_H_ */
