/***************************************************************************
 * This file is part of the BF527 doorbell application.                    *
 * Doorbell is a VOIP-based outdoor doorbell that can be run on SIP-based  *
 * telephone systems (PBX).                                                *
 *                                                                         *
 * Copyright (C) 2009,2010 by BerLinux Solutions GmbH                      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

#ifndef RINGTONETHREAD_H_
#define RINGTONETHREAD_H_

#include <mmstools/mmsthread.h>

class RingtoneThread: public MMSThread {
	private:
		string	ringtoneFile,
				busytoneFile,
				calltoneFile,
				ringtoneCmd,
				busytoneCmd,
				calltoneCmd;

		pthread_mutex_t	lock;
		pthread_cond_t	cond;
		enum {
			PLAY_NOTHING,
			PLAY_RINGTONE,
			PLAY_BUSYTONE,
			PLAY_CALLTONE
		} playCond;

		void threadMain();

	public:
		RingtoneThread(const string ringtoneFile, const string busytoneFile, const string calltoneFile);
		~RingtoneThread();

		void startRingtone();
		void startBusytone();
		void startCalltone();
		void stopTone();
};

#endif /* RINGTONETHREAD_H_ */
