/***************************************************************************
 * This file is part of the BF527 doorbell application.                    *
 * Doorbell is a VOIP-based outdoor doorbell that can be run on SIP-based  *
 * telephone systems (PBX).                                                *
 *                                                                         *
 * Copyright (C) 2009,2010 by BerLinux Solutions GmbH                      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

#ifdef __USE_LINPHONE__

#ifndef SIPBACKEND_LINPHONE_H_
#define SIPBACKEND_LINPHONE_H_

#include <linphone/linphonecore.h>

#include <mmstools/mmsthread.h>

#include "sipbackend.h"

class SipbackendLinphone : public MMSThread, public Sipbackend {
	public:
		SipbackendLinphone();
		virtual ~SipbackendLinphone();

		virtual bool initialize();
		virtual bool shutdown();

		virtual bool call(const std::string &user, const std::string &domain);
		virtual bool hangup();
		virtual bool answer();
		virtual bool isInitialized();
		virtual bool inCall();
		virtual bool inTrying();

		virtual void threadMain();

		void handleState(gstate_t, const char *);

	private:
		bool				linphoneInitialized;
		bool				quit;
		bool				inCallStatus;

		LinphoneCore		*sipCore;
		LinphoneCoreVTable	sipVTable;
		LinphoneProxyConfig *sipProxy;
		LinphoneAuthInfo 	*sipAuth;

		void initializeLinphone();
		bool registerAccount();
		void reRegisterAccount();
};

#endif /* SIPBACKEND_LINPHONE_H_ */

#endif /* __USE_LINPHONE__ */
