/***************************************************************************
 * This file is part of the BF527 doorbell application.                    *
 * Doorbell is a VOIP-based outdoor doorbell that can be run on SIP-based  *
 * telephone systems (PBX).                                                *
 *                                                                         *
 * Copyright (C) 2009,2010 by BerLinux Solutions GmbH                      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

#ifndef USERFILEREADER_H_
#define USERFILEREADER_H_

#include <mmstools/mmsfile.h>

struct User {
	int counter;
	string sipid;
	string name;
	string awayMsg;
	string code;
};
typedef std::map<std::string, User *> USER_MAP;

class UserFileReader
{
	public:
		UserFileReader(string userFileUri);
		virtual ~UserFileReader();

		bool read();
		vector<User *> getUsers();
	private:
		string uri;
		User u;
		vector<User *> users;

		void clearUsers();
};

#endif /* USERFILEREADER_H_ */
