/***************************************************************************
 * This file is part of the BF527 doorbell application.                    *
 * Doorbell is a VOIP-based outdoor doorbell that can be run on SIP-based  *
 * telephone systems (PBX).                                                *
 *                                                                         *
 * Copyright (C) 2009,2010 by BerLinux Solutions GmbH                      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

#include "absencedialog.h"

AbsenceDialog::AbsenceDialog(User *user, Sipbackend *sip) :
		Dialog::Dialog(),
		msgBox(NULL), 
		sip(sip), 
		user(*user) {
	loadDialog("absence.xml");

	this->msgBox = dynamic_cast<MMSTextBoxWidget *>(
			this->win->searchForWidget("messageBox"));
	if(this->msgBox && user) {
		this->msgBox->setText(user->awayMsg, true);
	}
}

AbsenceDialog::~AbsenceDialog() {

}

void AbsenceDialog::show() {
	if(win) {
		this->win->show();
		this->win->waitUntilShown();
		
	}

	if(sip->isInitialized()) {
		sip->call(this->user.sipid,"");
	}
}

void AbsenceDialog::hide() {
	if(win) {
		this->win->hide();
		this->win->waitUntilHidden();
	}
	if(this->sip)
		this->sip->hangup();
	onExit.emit(this, true);
}

void AbsenceDialog::setUser(User *user) {
	this->user = *user;
}
