/***************************************************************************
 * This file is part of the BF527 doorbell application.                    *
 * Doorbell is a VOIP-based outdoor doorbell that can be run on SIP-based  *
 * telephone systems (PBX).                                                *
 *                                                                         *
 * Copyright (C) 2009,2010 by BerLinux Solutions GmbH                      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

#include "errordialog.h"

ErrorDialog::ErrorDialog(std::string errorMsg,
		std::string timerMsg, int timerLength) :
		Dialog::Dialog(),
		timerMsg(timerMsg),
		timerLength(timerLength) {
	loadDialog("error.xml");

	this->errorBox = dynamic_cast<MMSTextBoxWidget *>(this->win->searchForWidget("errorMessageLabel"));
	if(this->errorBox) {
		this->errorBox->setText(errorMsg, true);
	}
	this->timerBox = dynamic_cast<MMSTextBoxWidget *>(this->win->searchForWidget("errorTimerLabel"));

}

ErrorDialog::~ErrorDialog() {

}


void ErrorDialog::showTimedMsg()
{
	if(!this->timerBox || this->timerMsg.empty()) {
		return;
	}

	if(this->timerLength == 0) {
		this->timerBox->setText(this->timerMsg, true);
		return;
	}

	char buff[1024];
	int ii = this->timerLength;
	while(ii > -1) {
		snprintf(buff, sizeof(buff), this->timerMsg.c_str(), ii--);
		this->timerBox->setText(buff, true);
		sleep(1);
	}
	sleep(1);

	this->timerBox->setText("", true);
}


void ErrorDialog::update(std::string errorMsg,
		std::string timerMsg, int timerLength) {
	if(!this->errorBox) {
		this->errorBox = dynamic_cast<MMSTextBoxWidget *>(this->win->searchForWidget("errorMessageLabel"));
		if(!this->errorBox)
			return;
	}

	this->errorBox->setText(errorMsg, true);
	this->timerMsg = timerMsg;
	this->timerLength = timerLength;
	this->timerBox->setText(this->timerMsg, true);
}
